<script setup lang="ts">
import { PropType, ref, defineProps } from 'vue';
import { JAvatar, JText, JButton, JSpinner } from '@new-jira-clone/ui/src/components';
import { type User } from '@/shared/api';

const props = defineProps({
  fetchGuest: {
    type: Function as PropType<() => Promise<User[]>>,
    required: true,
  },
  guestSignIn: {
    type: Function as PropType<(email: string) => Promise<void>>,
    required: true,
  },
});

const guestList = ref<User[]>([]);
const currentGuestLoader = ref<string | null>(null);

const getGuestList = async () => {
  try {
    guestList.value = await props.fetchGuest();
  } catch (error) {
    console.log(error);
  }
};

getGuestList();

const guestSignIn = async (user: User) => {
  currentGuestLoader.value = user.id;

  try {
    await props.guestSignIn(user.email);
  } catch (error) {
    console.log(error);
  } finally {
    currentGuestLoader.value = null;
  }
};
</script>

<template>
  <div class="guest-list-container">
    <JText
      weight="normal"
      type="text-1"
      color="text"
    >
      {{ $t('fast_sign_in') }}
    </JText>

    <div class="guest-list">
      <div
        v-for="user in guestList"
        :key="user.id"
        class="guest-list-item"
      >
        <JButton
          type="outlined"
          @keydown.enter="guestSignIn(user)"
          @keydown.space="guestSignIn(user)"
          @click="guestSignIn(user)"
        >
          <div class="test">
            <JAvatar v-show="user.id !== currentGuestLoader">
              <BaseImg
                :src="user.avatar"
                class="members-avatars"
              />
            </JAvatar>
            <JSpinner
              v-if="user.id === currentGuestLoader"
              width="20px"
              height="20px"
            />
            <span class="guest-label">{{ user.name }}</span>
          </div>
        </JButton>
      </div>
    </div>
  </div>
</template>

<style scoped lang="scss">
.guest-list-container {
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
}

.guest-list {
  display: flex;
  flex-wrap: wrap;
  justify-content: center;
  align-items: center;
  grid-gap: 20px;
  margin-top: 10px;
}

.guest-list-item {
  display: flex;
  flex-direction: column;
  align-items: center;
}

.test {
  display: flex;
  align-items: center;
}

.guest-label {
  margin-left: 6px;
}
</style>
